/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package paditbd1;

import java.sql.*;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.Collections;
import java.util.Vector;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;

/**
 *
 * @author maikelpg
 */
public class Conexion {

    private Connection con;
    private Statement stm;
    

    public Conexion(String host, String dbname, String port, String user, String password) throws SQLException {
        try {
            String driver = "org.postgresql.Driver";
            String connectString = "jdbc:postgresql://" + host + ":" + port + "/" + dbname;
            Class.forName(driver);
            this.con = DriverManager.getConnection(connectString, user, password);

            this.stm = this.con.createStatement();




        } catch (ClassNotFoundException ex) {
            JOptionPane.showMessageDialog(null, ex.toString());
        }
    }

    public boolean IsExistLanName(String lanname) throws SQLException {


        ResultSet rslanname = stm.executeQuery("select * from pg_language where lanname = 'plpgsql';");
        boolean result = rslanname.next();
        return result;

    }

    public Connection getConection() {
        return this.con;
    }

    public void createLang(String languaje) throws SQLException {
        ResultSet rs = stm.executeQuery("SELECT lanname from pg_catalog.pg_language where lanname = '"+languaje+"' ;");
        if (!rs.next()) {
            stm.execute("CREATE LANGUAGE '"+languaje+"';");
        }
    }

    public boolean IsTriggerCreated(String tgname) throws SQLException {

        ResultSet rs1 = stm.executeQuery("SELECT * FROM pg_trigger WHERE tgname = '" + tgname + "'; ");
        return rs1.next();
    }

    public void createFunction(String tabla,String name_function, String definicion) throws SQLException {


        stm.execute("CREATE OR REPLACE FUNCTION particionar_" + name_function + "() RETURNS trigger AS $emp_stamp$     BEGIN    " + definicion + "       END; $emp_stamp$ LANGUAGE 'plpgsql';");
        if (IsTriggerCreated("insert_"+name_function)) {
          stm.execute(" DROP TRIGGER insert_"+name_function+";" );
        }
         stm.execute("CREATE TRIGGER insert_"+name_function + " BEFORE INSERT  ON " + tabla + " FOR EACH ROW EXECUTE PROCEDURE particionar_"+name_function +"();");
         //stm.executeQuery("DELETE from " + tabla +" ;");
    }

    public Vector<String> Get_All_Tables(String query) throws SQLException {

        Vector<String> result = new Vector<String>();
        ResultSet rs2 = stm.executeQuery(query);
        while (rs2.next()) {
            result.add(rs2.getString(1));
        }
        return result;

    }

    public void Create_Tables_Hijas(String query) throws SQLException {
        stm.execute(query);

    }

    public Vector<String> Schemas(String query) throws SQLException {

        Vector<String> result_schemas = new Vector<String>();
        ResultSet rs3 = stm.executeQuery(query);
        while (rs3.next()) {
            result_schemas.add(rs3.getString(1));
        }
        return result_schemas;

    }

    public Vector<Vector> Datos_tablas(String query, int count_colum) throws SQLException {

        Vector<Vector> result_schemas = new Vector<Vector>();
        ResultSet rs4 = stm.executeQuery(query);
        while (rs4.next()) {
            Vector vector = new Vector();
            for(int i = 1 ; i <= count_colum ; i++)
            {
              vector.add(rs4.getString(i));
            }
            result_schemas.add(vector);
        }
        return result_schemas;

    }

    public int Count_Filas(String tabla) throws SQLException
    {
     ResultSet rs5 = stm.executeQuery("Select count(*) from "+tabla+"");
     rs5.next();
     return rs5.getInt(1);
    }

    public int Count_Columnas(String tabla) throws SQLException
    {
     ResultSet rs6 = stm.executeQuery("SELECT COUNT(*) FROM information_schema.columns WHERE table_name = "+tabla+";");
     rs6.next();
     return rs6.getInt(1);
    }

    public void Desconect() {
        try {
            this.con.close();
        } catch (SQLException ex) {
           JOptionPane.showMessageDialog(null, ex.toString());
        }
    }

    public  boolean  Ejecutar_Query(String query) throws SQLException
    {

        return    stm.execute(query);
    }

    public  String  Primary_Key(String query) throws SQLException
    {

        ResultSet rs7 = stm.executeQuery(query);
        rs7.next();
        return rs7.getString(1);

    }
}
